# Bewegungserkennung für RaspberryPi4

## Kühlung

**Der RasPi4 braucht mindestens eine passive Kühlung!** 


## Installation

```shell
# Paketlisten aktualisieren
e@s:~$ apt-get update

# Bibliotheken in system-libraries.txt installieren
e@s:~$ cat system-libraries.txt | while read library; do \
    sudo apt-get install --yes ${library}; done

# Python und Virtualenv installieren
e@s:~$ sudo apt-get install --yes python3 python3-virtualenv

# Redis installieren und konfigurieren
e@s:~$ sudo apt-get install --yes redis-server
e@s:~$ echo 'unixsocket /var/run/redis/redis-server.sock' \
    >> /etc/redis/redis.conf
e@s:~$ echo 'unixsocketperm 700' >> /etc/redis/redis.conf
e@s:~$ sudo systemctl restart redis-server.service

# Virtualenv erzeugen und aktivieren
e@s:~$ virtualenv v3
e@s:~$ source v3/bin/activate

# Python-Bibliotheken aus "requirements.txt" installieren
(v3) e@s:~$ pip install -r requirements.txt
```


## Enthaltene Skripte

- motion/detect.py
  
  Dies ist eigentliche Bewegungserkennung. Bei erkannter Bewegung
  werden die geänderten Pixel mit einem grünen Rahmen versehen und das
  Bild im lokalen Redis unter dem Schlüssel "detected" gesichert. Dort
  wird unter dem Schlüssel "motion" auch ein Marker abgelegt, der den
  Clients (siehe unten) anzeigt, ob aktuell Bewegung erkannt wurde. 

- reader/read.py
  
  Dieser Remote Client schaut auf dem Redis-Server, ob gerade eine
  Bewegung erkannt wird. Wenn das der Fall ist, wird sie angezeigt.
  
- saver/saver.py
  
  Arbeitet ähnlich wie reader/read.py, speichert die Bilder jedoch
  lokal ab. 
