#!/usr/bin/env python

import sys
import time
import dill as pickle
import logging
from io import BytesIO
from argparse import ArgumentParser

import cv2
import lz4.frame
import redis
import numpy as np

logging.basicConfig(
    format='%(asctime)s;%(levelname)s;%(message)s',
    level=logging.DEBUG,
    filename='log.txt'
)


if __name__ == '__main__':
    parser = ArgumentParser(description='read image from redis and display')
    parser.add_argument('--redishost', '-H', type=str, default='tv', help='the redis-server')    
    args = parser.parse_args()

    red = redis.Redis(host=args.redishost)
    
    while True:
        
        start = time.time()
        p = red.get('detected')
        
        '''
        memfile = BytesIO()
        memfile.write(p)
        memfile.seek(0)
        frame = np.load(memfile, allow_pickle=True)
        frame = pickle.loads(p)
        frame = pickle.loads(p)
        '''

        '''
        memfile = BytesIO()
        memfile.write(p)
        memfile.seek(0)
        frame = np.load(memfile)#, allow_pickle=True)
        '''
        #frame = pickle.loads(p)

        #frame = np.load(pickle.loads(p))
        #frame = np.load(p, allow_pickle=True)
        #frame = pickle.loads(p)

        frame = np.frombuffer(p, dtype=np.uint8).reshape((720, 1280, 3))
        
        cv2.imshow("Security Feed", frame)
        
        key = cv2.waitKey(1) & 0xFF
        if key == ord("q"):
            break
        
        logging.debug('full_loop_time;%0.5f'%(time.time() - start))
