#!/usr/bin/env python

OUTDIR = './out'

import os
import sys
import time
import pickle
import logging
from io import BytesIO
from argparse import ArgumentParser

import cv2
import lz4.frame
import redis
import numpy as np

logging.basicConfig(
    format='%(asctime)s;%(levelname)s;%(message)s',
    level=logging.DEBUG,
    filename='log.txt'
)

def savefile(*args, **kwargs):
    print('in subscribe: args =', args)
    print('in subscribe: kwargs =', kwargs)



if __name__ == '__main__':
    parser = ArgumentParser(description='read image from redis and display')
    parser.add_argument('--redishost', '-H', type=str, default='tv', help='the redis-server')    
    args = parser.parse_args()

    red = redis.Redis(host=args.redishost)
    sub = red.pubsub()
    sub.subscribe('motion')
    for msg in sub.listen():
        if int(msg['data']) == 1:
            p = red.get('detected')
            memfile = BytesIO()
            memfile.write(p)
            memfile.seek(0)
            frame = np.load(memfile)
            filename = os.path.join(OUTDIR, 'img_%f.jpg'%(time.time()))
            cv2.imwrite(filename, frame)
            logging.info('saved %s'%(filename))
